/*
    Copyright (C) 2006,2007 Olivier Goffart <ogoffart at kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/


#ifndef KCMCOLORS_H
#define KCMCOLORS_H

#include <kcmodule.h>



class KComboBox;
class KColorsConfigWidget;


class KCMColors : public KCModule
{
    Q_OBJECT

public:
    KCMColors(QWidget *parent, const QStringList &);
    virtual ~KCMColors();

    virtual void defaults();
    virtual void save();

public Q_SLOTS:
    virtual void load();

private Q_SLOTS:
    void slotAppActivated( const QString& app );

private:

    KComboBox *m_appCombo;
    KColorsConfigWidget *m_colorConfigWidget;

};



#endif
