/*  This file is part of the KDE Libraries
 *  Copyright (C)  2006   Olivier Goffart <ogoffart @ kde.org>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */


#ifndef KCOLORSETTINGS_H
#define KCOLORSETTINGS_H

#include <QtCore/QObject>

class KColorSettingsItem;

/**
	@author Olivier Goffart
*/
class KColorSettings : public QObject {
	Q_ENUMS(DefaultColor)
	Q_OBJECT
public:

    explicit KColorSettings(const QString& appname,QObject *parent=0);

    virtual ~KColorSettings();
	
	enum DefaultColor
	{
		ColorDefault = 0,
		Color1 = 1 ,
		Color2 = 2 ,
		Color3 = 3 ,
		Color4 = 4,
		Color5 = 5,
		Color6 = 6,
		Color7 = 7,
		Color8 = 8,
		ColorWindow = 0x0101,
		ColorButton = 0x0102,
		ColorToolTip = 0x0103,
		ColorHighlight = 0x0104,
		ColorWindowTitleActive = 0x0201,
		ColorWindowTitleInactive = 0x0202,
		
		/*ColorFocus = Color1,
			ColorLinkUnread= Color2,
			ColorLinkRead= Color3,
			ColorError= Color5,
			ColorTrusted= Color6,
			ColorEncrypted= Color7,
			ColorComment=Color8,*/
		
	};
		
	static KColorSettingsItem color( DefaultColor c );
	
	KColorSettingsItem color( const QString& key ) const;
	
	void setColor(const QString & key , const KColorSettingsItem&);
private:
	QString m_appname;
	static  KColorSettings* s_general;
};

#endif
