/**
 *  Copyright (C) 2005 Benjamin C Meyer (ben at meyerhome dot net)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

/**
 * TEST: just reasuring that qmap is indeed much slower then qhash
 * 
 */

#include <sys/time.h>
#include <qstring.h>
#include <qmap.h>
#include <qhash.h>

#define LOOP 1000000

int main( int /*argc*/, char /* *argv[]*/ ) {
	struct timeval tv1;
	struct timeval tv2;
		
	gettimeofday(&tv1, NULL);
  	QMap<int,int> map;
	for(int i=0; i< LOOP; i++){
		map.insert(i%9, 9);
	}

	gettimeofday(&tv2, NULL);
	qDebug("map  :  %d", (tv2.tv_usec-tv1.tv_usec));


	gettimeofday(&tv1, NULL);
	QHash<int,int> hash;
  	for(int i=0; i< LOOP; i++){
		hash.insert(i%9, 9);
	}
	gettimeofday(&tv2, NULL);
	
	qDebug("hash :  %d", (tv2.tv_usec-tv1.tv_usec));
	return 0;
}

