/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef VIEW_H
#define VIEW_H

#include <qwidget.h>
#include <qtimer.h>

namespace KNS {
class Entry;
}

class QTextEdit;
class KListView;
class Engine;
class AppStuff;
class AppView;
class QListViewItem;
class Installer;
class AppManager;
class QLabel;

class View : public QWidget
{
    Q_OBJECT
  public:
    View( QWidget *parent );
    ~View();

  public slots:
    void updateListing();

  protected slots:
    void addEntry( KNS::Entry * );
    void showEntry( QListViewItem * );

    void updateLastUpdateLabel();
    
    void slotInstallationFinished();
    void slotInstallationFailed( const QString & );

    void slotRetrievalError( const QString & );
    void slotRetrievalFinished();
    
    void periodicCheck();
    
  private:
    Engine *mEngine;

    KListView *mListView;
    AppView *mAppView;  

    AppStuff *mAppStuff;

    Installer *mInstaller;

    AppManager *mAppManager;

    QLabel *mLastUpdateLabel;

    QTimer mCheckTimer;
};

#endif
