/*******************************************************************************
 *                                                                             *
 * klbkonqplugin is a menu plugin for konqueror for klabelbrowser              *
 * Copyright (C) 2005  Ramakrishna R <coolrama@gmail.com>                      *
 *                                                                             *
 * This program is free software; you can redistribute it and/or modify        *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation; either version 2 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program; if not, write to the Free Software                 *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. *
 *                                                                             *
 ******************************************************************************/


#include <khtml_part.h> // this plugin applies to a khtml part
#include <kdebug.h>
#include "klbkonqplugin.h"
#include <kinstance.h>
#include <klocale.h>
#include <kgenericfactory.h>
#include <kparts/browserextension.h>
#include<kapplication.h>
 
KlbPlugin::KlbPlugin( QObject* parent, const char* name, const QStringList & /*args*/ )
    : Plugin( parent, name )
{
    klbmenu = new KSelectAction( i18n("Label Browser"),
                                   "reload", 0,
                                   this, SLOT(slotSelected()),
                                   actionCollection(), "klbkonqplugin" );

    QStringList sl;
    sl << i18n("Home");
    sl << i18n("New Label");
    sl << i18n("Apply Label");

    klbmenu->setItems( sl );
}
 
KlbPlugin::~KlbPlugin()
{
}

void KlbPlugin::slotSelected()
{
  
  KParts::ReadOnlyPart *part = (KParts::ReadOnlyPart *) parent();

   int i = klbmenu->currentItem();
   switch (i) {
     case 0:
	part->openURL("klb:/");
         break;
     case 1:
	part->openURL("klb:/create");
        break;
     case 2:
	part->openURL("klb:/apply");
         break;
    default:
         break;
   }

}

K_EXPORT_COMPONENT_FACTORY( libklbkonqplugin, KGenericFactory<KlbPlugin>( "klbkonqplugin" ) )

#include "klbkonqplugin.moc"

