/*******************************************************************************
 *                                                                             *
 * applylabel is a command line interface 			               *
 * Copyright (C) 2005  Ramakrishna R <coolrama@gmail.com>  	               *
 *                                                                             *
 * This program is free software; you can redistribute it and/or modify        *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation; either version 2 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program; if not, write to the Free Software                 *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. *
 *                                                                             *
 ******************************************************************************/


#include<lbapi.h>
#include<iostream>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kdebug.h> 
#include <kinstance.h> 

using namespace std;
using namespace KLB;

char * appname = "applylabel";
char * progName = "applylabel.cpp";
char * description = "applies label to filepaths";
char * progDisplay = "ApplyLabel";
char * progVersion = "0.1";

static KCmdLineOptions options[] =
{
  { "n",0,0},
  { "name <name>",
    I18N_NOOP( "label name" ), 0 },
  { "p",0,0},
  { "path <path>",
    I18N_NOOP( "filepath to which label is appied" ), 0 },
 KCmdLineLastOption 
};


int main(int argc, char * argv[])
{
KAboutData aboutData(
    progName,                        // internal program name
    I18N_NOOP( progDisplay ),
    progVersion,                     // version string
    I18N_NOOP( description ),           // short porgram description
    KAboutData::License_GPL,         // license type
    " ", // copyright statement
    0,                               // any free form text
    "",                         // program home page address
    "bugs.kde.org"                   // bug report email address
    );

       aboutData.addAuthor( "Ramakrishna R", "Author", " " );	

	KCmdLineArgs::init( argc, argv, &aboutData, true );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

	KInstance ins( progName );
	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

//	cout << args->count() <<endl;

	if(!(args->isSet("name"))&&(args->isSet("path")))
	{
		cout << "Usage: applyLabel labelname filePath \n";
		exit(1);
	}
	
//	cout<<(args->isSet("name") ? "set" : "not set")<<endl;
//	cout<<args->getOption("name")<<endl;

	KLB::LabelManager* name = new KLB::LabelManager();
	name->applyLabel(args->getOption("name"),args->getOption("path"));
}
