/*
   This file is part of the KDE project
   Copyright (C) 2009 by Dmitry Suzdalev <dimsuz@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include <KUniqueApplication>
#include <KAboutData>
#include <KCmdLineArgs>
#include <KDebug>

int main(int argc, char** argv)
{
    KAboutData aboutData("klipper", 0, ki18n("Klipper"),
                         "0.1", ki18n("descr"), KAboutData::License_GPL,
                         ki18n("(c) 1998, Andrew Stanley-Jones\n"
                               "1998-2002, Carsten Pfeiffer\n"
                               "2001, Patrick Dubroy"));

    KCmdLineArgs::init( argc, argv, &aboutData);
    KUniqueApplication::addCmdLineOptions();

    if (!KUniqueApplication::start()) {
        kDebug() << "Klipper is already running!";
        exit(0);
    }

    KUniqueApplication app;
    app.disableSessionManagement();
    app.setQuitOnLastWindowClosed( false );

    return app.exec();
}
