/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include "klipboarddelegate.h"
#include <QApplication>
#include <QPainter>

#include <KGlobalSettings>

#include "klipboardmodel.h" // for Roles enum

KlipboardDelegate::KlipboardDelegate(QObject* parent)
    : Plasma::Delegate(parent)
{

}

QSize KlipboardDelegate::sizeHint(const QStyleOptionViewItem& opt, const QModelIndex& index) const
{
//    QSize origHint = QStyledItemDelegate::sizeHint(opt, index);

    // TODO replace it with calculation of needed height. currently testing only
    return QSize(150, 48);
}

/*
void KlipboardDelegate::paint(QPainter* painter, const QStyleOptionViewItem& opt, const QModelIndex& index) const
{
    painter->save();
    QStyleOptionViewItemV4 option(opt);
    initStyleOption(&option, index);

    //
    // Draw item with no textwith a decoration and selection (if it's selected)
    //

    // we want to paint text by ourselves, so set it to null, paint selection and then paint text
    QString text = index.data(Qt::DisplayRole).toString();
    option.text = QString();
    option.decorationSize = QSize(32, 32);

    QStyle* style = QApplication::style();
    style->drawControl(QStyle::CE_ItemViewItem, &option, painter, 0);

    if (option.state & QStyle::State_Selected)
        painter->setPen(option.palette.color(QPalette::Normal, QPalette::HighlightedText));
    else
        painter->setPen(option.palette.color(QPalette::Normal, QPalette::Text));

     //
     // Draw text
     //
    int marginH = style->pixelMetric( QStyle::PM_FocusFrameHMargin );
    int marginV = style->pixelMetric( QStyle::PM_FocusFrameVMargin );

    QRect r = opt.rect.adjusted(marginH*2 + option.decorationSize.width(),
                                marginV,
                                0, 0);

    int flags = Qt::AlignLeft | Qt::AlignTop | Qt::TextSingleLine;
    QFontMetrics fm(painter->font());
    QString elided = fm.elidedText(text, Qt::ElideMiddle, r.width(), flags);
    painter->drawText(r, flags, elided);

    //
    // Draw misc info
    //
    if (option.state & QStyle::State_Selected)
        painter->setPen(option.palette.color(QPalette::Disabled, QPalette::HighlightedText));
    else
        painter->setPen(option.palette.color(QPalette::Disabled, QPalette::Text));

    r = r.adjusted(0, fm.lineSpacing(), -marginH*2, 0);
    flags = Qt::AlignRight | Qt::AlignVCenter;

    painter->setFont(KGlobalSettings::smallestReadableFont());

    bool isSelection = index.data(KlipboardModel::IsSelectionRole).toBool();
    // TODO: i18n!
    painter->drawText(r, flags, isSelection ? "Selection" : "Clipboard");

    painter->restore();
}
*/
