/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef KLIPPER_APPLET_H
#define KLIPPER_APPLET_H

#include <Plasma/PopupApplet>

class KlipperWidget;

class KlipperApplet : public Plasma::PopupApplet
{
    Q_OBJECT

public:
    KlipperApplet(QObject *parent, const QVariantList &args);
    ~KlipperApplet();

private:
    virtual void init();
    virtual void constraintsEvent(Plasma::Constraints constraints);
    void popupEvent(bool shown);

    /**
     * The widget that displays the calendar.
     */
    virtual QGraphicsWidget *graphicsWidget();

    /**
     * Creates and initializes a popup widget
     */
    void createPopupWidget();

    void focusInEvent(QFocusEvent*);

private slots:
    void onShowPopupActionTriggered();

private:
    QGraphicsWidget* m_popup;
    KlipperWidget* m_klipWidget;
};

K_EXPORT_PLASMA_APPLET(klipper, KlipperApplet)

#endif
