/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef KLIPPER_WIDGET_H
#define KLIPPER_WIDGET_H

#include <QWidget>

#include <Plasma/DataEngine>

class QListView;
class KlipboardModel;
class QModelIndex;
class QFocusEvent;

class KlipperWidget : public QWidget
{
    Q_OBJECT

public:
    KlipperWidget(QWidget* parent = 0);

    void setClipboardEngine(Plasma::DataEngine* engine);

signals:
    /**
     * Emitted when current selected entry changes
     */
    void currentEntryChanged();

private slots:
    void onActivated(const QModelIndex&);
    void onSourceAdded(const QString&);

    void dataUpdated(const QString&, const Plasma::DataEngine::Data& data);

private:
    bool eventFilter(QObject* obj, QEvent* ev);

private:
    QListView* m_listView;
    Plasma::DataEngine* m_engine;
    KlipboardModel* m_model;
};

#endif
