#ifndef _BACKUP_SERVICE_ADAPTOR_H_
#define _BACKUP_SERVICE_ADAPTOR_H_

#include <QObject>
#include <QtDBus>

class BackupService;
class BackupThread;

class BackupServiceAdaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.kde.nepomuk.BackupService")
    Q_CLASSINFO("D-Bus Introspection", ""
                "  <interface name=\"org.kde.nepomuk.BackupService\" >\n"
                "    <method name=\"startBackup\" >\n"
                "    </method>\n"
                "  </interface>\n"
                "")

public:
    BackupServiceAdaptor( BackupService* parent );
    ~BackupServiceAdaptor();

public slots:
    void startBackup();

private:
    BackupThread * m_thread;

};

#endif
