/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef RESOURCELOG_H
#define RESOURCELOG_H

#include <QtCore/QUrl>
#include <QtCore/QMultiHash>

namespace Nepomuk {
    namespace Sync {

        class ChangeLog;
        class ChangeLogRecord;
        
        class ResourceLog
        {
        public:
            QUrl uri;
            QMultiHash<QUrl, ChangeLogRecord> prop;
        };

        typedef QHash<QUrl, ResourceLog> ResourceLogMap;

        /**
         * Convinience functions to create a MergeHash
         */
        ResourceLogMap createResourceLogMap( const QList<ChangeLogRecord> & records );
        
        /**
         * Convinience functions to create a MergeHash
         */
        ResourceLogMap createResourceLogMap( const Nepomuk::Sync::ChangeLog& log );

        void optimizeResourceLogMap( ResourceLogMap & logmap );
    }
}
#endif // RESOURCELOG_H
