/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef TOOLS_H
#define TOOLS_H

#include <QtCore/QList>

namespace Soprano {
    class Statement;
    class Model;
}

namespace Nepomuk {

    
    class SyncFile;
    
    
    /**
     * Returns a list of all the statements that should be backed up. It's useful in cases
     * like doing a first sync or first backup.
     */
    QList<Soprano::Statement> getBackupStatements();

    SyncFile createFirstSyncFile();

}

#endif // TOOLS_H
