/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef RESOURCEEDITDIALOG_H
#define RESOURCEEDITDIALOG_H

#include <KDialog>

#include <Nepomuk/Resource>

#include "nepomuksearchgui_export.h"

class QWidget;

namespace Nepomuk
{
    /**
      * Convenince dialog to use ResourceEditWidget for displaying/editing a resource
      */

    class NEPOMUKSEARCHGUI_EXPORT ResourceEditDialog : public KDialog
    {
        Q_OBJECT

    public:
        ~ResourceEditDialog();

        /**
          * Displays a ResourceEditWidget for viewing or editing a resource
          */
        static void editResource(const Nepomuk::Resource &resource = Nepomuk::Resource(), QWidget * parent = 0);

    private:
        ResourceEditDialog(const Nepomuk::Resource &resource = Nepomuk::Resource(), QWidget *parent = 0, Qt::WFlags flags = 0);

        class Private;
        Private * const d;
    };
}


#endif // RESOURCEEDITDIALOG_H
