/*
 * This file is part of Search Project.
 *
 * Copyright (C) 2007 Daniele Galdi <daniele.galdi@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef STRIGI_HITS_MODEL_H
#define STRIGI_HITS_MODEL_H

#include <QAbstractListModel>

class StrigiHit;

class StrigiHitsModel: public QAbstractItemModel
{
  Q_OBJECT

public:
  StrigiHitsModel( QObject * parent = 0 );
  virtual ~StrigiHitsModel();

  QModelIndex parent( const QModelIndex &child ) const;
  QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;

  int columnCount(const QModelIndex& parent) const;
  int rowCount( const QModelIndex& parent ) const;
  QVariant data( const QModelIndex& index, int role ) const;

  void setHits( const QList<StrigiHit> &hits );
  void invalidateLayout();

public slots:
  void groupBy( const QString& group );

private:
  class Private;

  Private *d;
};

#endif // STRIGI_HITS_MODEL_H
