/*
 * This file is part of Search Project.
 *
 * Copyright (C) 2007 Daniele Galdi <daniele.galdi@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef TREE_VIEW_H
#define TREE_VIEW_H

#include <QTreeView>
#include <QModelIndex>
#include <QAbstractItemModel>

class TreeView : public QTreeView
{
  Q_OBJECT

public:
  explicit TreeView( QWidget *parent = 0 );
  virtual ~TreeView();

protected:
  void drawRow( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
  void drawBranches( QPainter * painter, const QRect & rect, const QModelIndex & index ) const;

public slots:
  void stateChanged( const QModelIndex &index );

  void destroyWidget( const QModelIndex &index );
};

#endif // TREE_VIEW_H
