/* 
 *
 * $Id: sourceheader 511311 2006-02-19 14:51:05Z trueg $
 *
 * This file is part of the Nepomuk KDE project.
 * Copyright (C) 2006 Sebastian Trueg <trueg@kde.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#include "queryservicetest.h"

#include <knepomuk/registry.h>
#include <knepomuk/service.h>
#include <knepomuk/services/queryservice.h>
#include <knepomuk/services/statementlistiterator.h>

using namespace Nepomuk::Backbone;
using namespace Nepomuk::Backbone::Services;
using namespace Nepomuk::Backbone::Services::RDF;


static QString s_query("select ?a ?b ?c where {?a ?b ?c}");

QueryServiceTest::QueryServiceTest()
  : QObject()
{
  m_registry = new Registry( this );
}


void QueryServiceTest::initTestCase()
{
  m_service = m_registry->discoverServiceByType( "http://nepomuk.semanticdesktop.org/services/storage/rdf/Query" );
  QVERIFY( m_service != 0 );
}


void QueryServiceTest::testExecuteQuery()
{
  QueryService tsw( m_service );

}


void QueryServiceTest::testIterator()
{
  QueryService tsw( m_service );

}


QTEST_MAIN(QueryServiceTest)

#include "queryservicetest.moc"
