/***************************************************************************
 *   Copyright 2008 by Thomas Schildknecht <danakil.kde@gmail.com>         *
 *   Copyright 2010 by Stefan Majewsky <majewsky@gmx.net>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 *                                                                         *
 ***************************************************************************/

#ifndef ACTIVEWINDOWCONTROL_H
#define ACTIVEWINDOWCONTROL_H

#include "button.h"
#include "windowmanager.h"
#include "ui_activewindowcontrolConfig.h"

#include <Plasma/Applet>
class QGraphicsLinearLayout;

class ActiveWindowControl : public Plasma::Applet
{
    Q_OBJECT

    public:
        enum CycleWindowsMode {
            CycleOnCurrentDesktop = 0,
            CycleOnAllDesktops,
            CycleDisabled
        };

        ActiveWindowControl(QObject *parent, const QVariantList &args);
        void init();

        virtual void createConfigurationInterface(KConfigDialog* parent);
    public Q_SLOTS:
        void slotActionAdded(QListWidgetItem *item);
        void slotActionRemoved(QListWidgetItem *item);
    protected Q_SLOTS:
        void configAccepted();
    Q_SIGNALS:
        /// Triggered when the scrollwheel is used on the icon
        /// \param direction +1 means up, -1 means down
        void scrollWheelOnIcon(int direction);
    protected:
        virtual void wheelEvent(QGraphicsSceneWheelEvent* event);
    private:
        QListWidgetItem* buildItem(Awc::ButtonType buttonType) const;
        void rebuildButtons();

        //other objects
        Awc::WindowManager* m_windowManager;
        QList<Awc::Button*> m_buttons;
        QGraphicsLinearLayout* m_layout;
        Ui::activewindowcontrolConfig m_uiConfig;
        //properties
        bool m_isVerticalLayout;
        QList<int> m_buttonTypes;
        //state
        bool m_isOnPanel;
};

#endif // ACTIVEWINDOWCONTROL_H
