/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef ICON_CELL_H_
#define ICON_CELL_H_

#include "abstractcell.h"

#include <Plasma/IconWidget>

/**
 * Uses a Plasma::IconWidget to display -- guess what.
 */
class IconCell: public AbstractCell
{
Q_OBJECT

public:
	/**
	 * Constructor
	 * @param id Property key identifying the picture/icon path
	 * @param fallbackIcon KIcon fallback used if the value() for the key is empty
	 * @param properties Contacts properties
	 * @param parent Parent widget
	 */
	IconCell(const QString id, const QString &fallbackIcon, const QVariantMap &properties, QGraphicsWidget *parent);

	/** Destructor */
	virtual~ IconCell();

	/**
	 * Reimplemented from AbstractCell
	 */
	virtual void propertiesChanged(const QVariantMap &properties);

private:
	/** Property key identifying the picture/icon path */
	const QString m_id;

	/** KIcon fallback used if the value() for the key is empty */
	const QString m_fallbackIcon;

	/** Icon used for displaying */
	Plasma::IconWidget *m_icon;
};

#endif // ICON_CELL_H_
