/*
    Copyright (C) 2009  George Kiagiadakis <kiagiadakis.george@gmail.com>

    This library is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _QTGSTREAMER_QGSTCOLORBALANCE_H
#define _QTGSTREAMER_QGSTCOLORBALANCE_H

#include <QList>
#include "../qgstelement.h"
#include "qgstcolorbalancechannel.h"
#include <gst/gst.h>

namespace QtGstreamer {

class QGstColorBalance
{
public:
    //enum ColorBalanceType { Hardware, Software };
    QGstColorBalance(const QGstElementPtr & element);
    ~QGstColorBalance();

    static bool isColorBalance(const QGstElementPtr & element);
    
    //ColorBalanceType getBalanceType();
    QList<QGstColorBalanceChannelPtr> listChannels() const;
    int getValue(const QGstColorBalanceChannelPtr &channel);
    void setValue(const QGstColorBalanceChannelPtr &channel,int value);
    void valueChanged(const QGstColorBalanceChannelPtr &channel,int value);

private:
    QGstElementPtr m_element;
};

}

#endif
