/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#ifndef INFO_WIDGET_H
#define INFO_WIDGET_H

#include <QGraphicsWidget>
#include <QFont>

class QTimer;

namespace Plasma
{
    class Svg;
    class FrameSvg;
}

class InfoWidget : public QGraphicsWidget
{
    Q_OBJECT
public:
    InfoWidget(QGraphicsWidget *parent,Plasma::Svg *svg);
    ~InfoWidget();

    void startCountDown(int counter);
    void paint(QPainter *painter, const QStyleOptionGraphicsItem * option, QWidget* widget = 0);

    void setSize(QSizeF size);

protected slots:
    void appearAnimation(qreal animationvalue);
    void disappearAnimation(qreal animationvalue);

private Q_SLOTS:
    void slotCountDownTimer();

signals:
    void countDownFinished();

private:
    bool mCountDownRunning;
    int mMaxCountDownSecond;
    int mCountDownSecond;

    QSizeF mSize;
    Plasma::Svg *mSvg;
    Plasma::FrameSvg *mFrameSvg;
    QTimer *mCountDownTimer;
    QRectF mWidgetRect;
    QRectF mCircleRect;
    QPointF mNumberPosition;
    QFont mNumberFont;
    qreal mOpacity;
    int mCircleSize;
};

#endif