/***************************************************************************
 *   Copyright (C) 2010 Reza Fatahilah Shah <rshah0385@kireihana.com>      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PLASMA_LISTVIEW_H
#define PLASMA_LISTVIEW_H

#include <QtGui/QGraphicsProxyWidget>

class QListView;
class QAbstractItemModel;
class ListViewPrivate;

class ListView : public QGraphicsProxyWidget
{
    Q_OBJECT
    public:
        ListView(QGraphicsWidget *parent = 0);
        ~ListView();
        
        void setModel(QAbstractItemModel *model);
        QAbstractItemModel *model();
        
        QListView *nativeWidget() const;
        
    private:
        ListViewPrivate *const d;
};

#endif