/***********************************************************************************
* Copyright (C) 2009 Marcin Baszczewski <marcin.baszczewski@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef TASKSMENU_H
#define TASKSMENU_H

#include <QBoxLayout>
#include <QGridLayout>
#include <QPixmap>
#include <QWidget>
#include <QLabel>
#include <QPainter>
#include <QPaintEvent>
#include <QEvent>
#include <QMouseEvent>

#include <Plasma/FrameSvg>

#include "abstracttaskitem.h"
#include <taskmanager/groupmanager.h>
#include <KWindowSystem>
#include <NETRootInfo>

class QRectF;
class QSizeF;
class WindowPreview;

class TasksMenu : public QWidget
{
    Q_OBJECT

    public:
        TasksMenu(int size, QWidget *parent);
        ~TasksMenu();
     
    signals:
        void mouseHovering(bool);
        
    protected:
        void paintEvent(QPaintEvent *event);
        void resizeEvent(QResizeEvent *event);
        void enterEvent(QEvent *event);
        void leaveEvent(QEvent *event);
        void mousePressEvent(QMouseEvent *event);

    public slots:
        void setTasks(QList<AbstractTaskItem*> tasks);
        void show();
        void updateTheme();

    private:
        QList<WindowPreview*> m_previews;
        QGridLayout *m_mainLayout;
        QGridLayout *m_tasksLayout;
        Plasma::FrameSvg *m_background;
        bool m_alreadyShown;
        bool m_previewsAvailable;
        int m_size;
        QList<AbstractTaskItem*> m_tasks;
};

#endif
