/*
    Copyright (C) 2010 Ariya Hidayat <ariya@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PLASMA_APPLET_MORPHINGCLOCK
#define PLASMA_APPLET_MORPHINGCLOCK

#include <Plasma/Applet>
#include <Plasma/DataEngine>
#include <Plasma/Svg>
 
class QTimeLine;
 
class MorphingClock : public Plasma::Applet
{
    Q_OBJECT
    public:
        MorphingClock(QObject *parent, const QVariantList &args);
 
        void init();
        void constraintsEvent(Plasma::Constraints constraints);
        QPainterPath shape() const;
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
 
    public slots:
        void dataUpdated(const QString &name, const Plasma::DataEngine::Data &data);

    private slots:
        void adjustSize();
        void updateTransition();

    protected:
        void mousePressEvent(QGraphicsSceneMouseEvent *event);

    private:
        qreal radius;
        qreal digitWidth;
        QFont font;
        QPolygonF sourcePoly[4];
        QPolygonF targetPoly[4];
        int targetLevel[4];
        QTimeLine *timeLine;
};
 
K_EXPORT_PLASMA_APPLET(morphingclock, MorphingClock)
 
#endif
