/*
 * Copyright (C) 2008 Laura Dragan <aprilush@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef NEPOMUKTAGS_APPLET_H_
#define NEPOMUKTAGS_APPLET_H_

#include <Plasma/Applet>
#include <Plasma/Label>
#include <Plasma/DataEngine>
#include <QString>
#include <QMap>
#include <KColorScheme>
#include "ui_configuration.h"

class NepomukTagsApplet: public Plasma::Applet
{
    Q_OBJECT

public:
    NepomukTagsApplet(QObject *parent, const QVariantList &args);
    ~NepomukTagsApplet();

    void init();

public slots:
    void dataUpdated(const QString &name, const Plasma::DataEngine::Data &data);
    void createConfigurationInterface(KConfigDialog *parent);

private slots:
    void configAccepted();
    void openSearch(const QString &link);
    void themeChanged();

private:
    void updateText();

private:
    QMap<QString, QVariant> m_tagCount;
    QString m_text;
    int m_minSize;
    int m_maxSize;
    int m_min;
    int m_max;
    KColorScheme *m_colorScheme;
    Plasma::Label *m_label;
    Plasma::DataEngine *m_engine;
    Ui::NepomukTagsConfiguration m_configUi;

};

#endif /* NEPOMUKTAGS_APPLET_H_ */
