#include "openbrainsettings.h"

#include <kfiledialog.h>
#include <kurl.h>
#include <kdebug.h>

#include <QMessageBox>
#include <QProcess>
#include <QDir>

OpenBrainSettings::OpenBrainSettings(QWidget *parent) : QWidget(parent)
{
   setupUi(this);
}

OpenBrainSettings::~OpenBrainSettings()
{

}

void OpenBrainSettings::installAimlSet()
{
    QString path = KFileDialog::getExistingDirectory(KUrl(), this, "Select AIML Folder");
    kDebug() << path;
    QProcess p;
    p.start("cp -a \"" + path + "\" \"" + QDir::homePath() + "/.openbrain/aiml\"");
    if(!p.waitForFinished())
        QMessageBox::information(this, i18n("Error"), i18n("Could not copy AIML Set (permission denied.)"));
    this->comboAimlSet->insertItem(0, QDir(path).dirName());
    this->comboAimlSet->setCurrentIndex(0);
}

void OpenBrainSettings::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
       retranslateUi(this);
        break;
    default:
        break;
    }
}
