/***************************************************************************
 *   Copyright (C) 2008 by Matej Svejda <mata@aw-modell.at>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PEACHY_ANIMATOR
#define PEACHY_ANIMATOR

#include <QObject>
#include <QList>

class PeachyApplet;
class PeachyIcon;

class PeachyAnimator : public QObject
{
	Q_OBJECT
	public:
		PeachyAnimator(qreal scaling, PeachyApplet* parent);
		~PeachyAnimator();
		void add(PeachyIcon* icon);
		void remove(PeachyIcon* icon);
		void clear();
		void setMinimumScaling(qreal scaling);
		void reinit();
	private slots:
		void iconGotHover(PeachyIcon* icon, qreal across);
	signals:
		void needsRelayout();
	private:
		QList<PeachyIcon*> m_icons;
		qreal m_minimumScaling;
};

#endif
