/***************************************************************************
 *   Copyright (C) 2009 by Kai Dombrowe <just89@gmx.de>                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef PGAME
#define PGAME


// own
#include "ui_settings.h"

// KDE
#include <Plasma/PopupApplet>
#include <KUrl>


namespace Plasma {
    class ScrollWidget;
}

class Game;
class KConfigDialog;
class GameList;
class PGame : public Plasma::PopupApplet, public Ui::Settings
{
    Q_OBJECT


public:
    PGame( QObject *parent, QVariantList args );
    ~PGame();
    void init();

    QList<QAction*> contextualActions();                  

    
public slots:
    virtual void destroy();

        
private:
    QGraphicsWidget *m_widget;
    GameList *m_gameList;
    Plasma::ScrollWidget *m_list;
    
    
private slots:
    void newGame();
    void gameDrop(const QPointF &pos, const KUrl &file);
    void saveGames();
    void loadGames();
    void createConfigurationInterface(KConfigDialog *parent);
    void configAccepted();


protected:
    QGraphicsWidget* graphicsWidget();
    

};



#endif
