/***************************************************************************
 *   Copyright (C) 2010 by Tomaz Canabrava <tcanabrava@kde.org>                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

// Here we avoid loading the header multiple times
#ifndef RECENTDOCUMENTS_HEADER
#define RECENTDOCUMENTS_HEADER

#include <Plasma/Applet>
#include <Plasma/DataEngine>

class QSizeF;
class QGraphicsLinearLayout;
class QGraphicsSceneMouseEvent;
class IconWidget;

namespace Plasma{
    class ItemBackground;
}

// Define our plasma Applet
class RecentAppDocumentsApplet : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        RecentAppDocumentsApplet(QObject *parent, const QVariantList &args);
        ~RecentAppDocumentsApplet();

        void init();
        
    signals:
        void recentDocumentSelected(const QString& doc);
        void openFileDialog();
        
    public slots:
        void    dataUpdated (const QString &sourceName, const Plasma::DataEngine::Data &data);
        
    private slots:
        void recentDocumentSelectedEmiter();

    private:
        bool m_showInfo;
        QGraphicsLinearLayout *m_contentLayout;
        Plasma::ItemBackground *m_background;
        QGraphicsItem *m_hovered;
        QList<IconWidget*> iconList;
        
};
 
// This is the command that links your applet to the .desktop file
#endif
