/***************************************************************************
 *   Copyright 2007 by Marco Martin <notmart@gmail.com>                    *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef SVGPANELTEST_H
#define SVGPANELTEST_H


#include <QGraphicsView>


#include <plasma/applet.h>

#include "ui_panelconfig.h"

namespace Plasma
{
class FrameSvg;

class SvgPanelTest : public Plasma::Applet
{
    Q_OBJECT
    public:
        SvgPanelTest(QObject *parent, const QVariantList &args);
        ~SvgPanelTest();

        void init();
        void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option,
                            const QRect &contents);
        Qt::Orientations expandingDirections() const;

    public slots:
        void createConfigurationInterface(KConfigDialog *parent);

    protected slots:
        void configAccepted();

    protected:
        void constraintsEvent(Plasma::Constraints constraints);

    private:
        void updateFlags();

        FrameSvg *m_panel;

        QString m_SvgFileName;
        QString m_Prefix;
        bool m_DrawTop;
        bool m_DrawBottom;
        bool m_DrawLeft;
        bool m_DrawRight;

        // Designer Config file
        Ui::PanelConfig ui;
        KDialog *m_dialog;
};

K_EXPORT_PLASMA_APPLET(SvgPanelTest, SvgPanelTest)

} // Plasma namespace

#endif
