#ifndef WEBBYEFFECT_H
#define WEBBYEFFECT_H

#include <QGraphicsDropShadowEffect>

class WebbyEffectPrivate;

class WebbyEffect : public QGraphicsDropShadowEffect
{
    Q_OBJECT

public:
    WebbyEffect(QObject *parent);
    ~WebbyEffect();

    /** Set the pixmap that should be used for the reflection - yuck! */
    void setReflectionPixmap( const QPixmap &reflect );
    void setReflectionImage( const QImage &reflect );

    void setReflectionPosition( const QPointF &pos );

    QRectF boundingRectFor(const QRectF &rect) const;

protected:
    void draw(QPainter * painter);

private:
    WebbyEffectPrivate *d;
};

#endif // WEBBYEFFECT_H

