/*
 *   Copyright (C) 2009 Ivan Cukic <ivan.cukic@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef GMAILENGINE_H
#define GMAILENGINE_H

#include <Plasma/DataEngine>
#include <Plasma/Service>
#include <Plasma/ServiceJob>
#include <QMap>

class GmailEngine: public Plasma::DataEngine {
    Q_OBJECT

public:
    GmailEngine(QObject * parent, const QVariantList & args);
    ~GmailEngine();

    Plasma::Service * serviceForSource(const QString & name);

protected:
    // override DataEngine
    bool sourceRequestEvent(const QString & name);
    bool updateSourceEvent(const QString & source);
    void reload();

private:
    class Private;
    Private * const d;
};

K_EXPORT_PLASMA_DATAENGINE(lancelot_gmail, GmailEngine)

#endif // GMAILENGINE_H
