/***************************************************************************
 *   Copyright (C) 2007 by Teemu Rytilahti <tpr@d5k.net>                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#ifndef _ION_WILLAB_H
#define _ION_WILLAB_H

#include "plasma/weather/ion.h"

#include <QtXml/QXmlStreamReader>

class QXmlStreamReader;

class KUrl;

class KDE_EXPORT WillabIon : public IonInterface {
    Q_OBJECT

    public:
        WillabIon(QObject *parent, const QVariantList &args);
        ~WillabIon();

        void init();   // Ion setup - Implemented by Ion plugin
        void fetch();  // Get the Ion's data - Implemented by Ion plugin

        bool updateIonSource(const QString &);
        void updateData(); // Update the Ions weather information

    public Q_SLOTS:
        void reset();

    private Q_SLOTS:
        void dataFetched(KIO::Job *, const QByteArray &);
        void fetchingDone(KJob *);

    private:
        KUrl m_url;
        QString m_source;
        QXmlStreamReader m_reader;
        KIO::Job *m_transferJob;
        bool m_isFetching;
        DataEngine::Data m_data;

};

K_EXPORT_PLASMA_DATAENGINE(willab, WillabIon)

#endif // _ION_WILLAB_H
