/////////////////////////////////////////////////////////////////////////
// red.cpp                                                             //
//                                                                     //
// Copyright (C)  2010  Adenilson Cavalcanti <cavalcantii@gmail.com>   //
//                                                                     //
// This library is free software; you can redistribute it and/or       //
// modify it under the terms of the GNU Lesser General Public          //
// License as published by the Free Software Foundation; either        //
// version 2.1 of the License, or (at your option) any later version.  //
//                                                                     //
// This library is distributed in the hope that it will be useful,     //
// but WITHOUT ANY WARRANTY; without even the implied warranty of      //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   //
// Lesser General Public License for more details.                     //
//                                                                     //
// You should have received a copy of the GNU Lesser General Public    //
// License along with this library; if not, write to the Free Software //
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA       //
// 02110-1301  USA                                                     //
/////////////////////////////////////////////////////////////////////////

#include "red.h"
#include <QPainter>
#include <QStyleOptionGraphicsItem>

RedWidget::RedWidget(QGraphicsItem * parent, Qt::WindowFlags wFlags): QGraphicsWidget(parent)
{

}

void RedWidget::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
{
    if (icon.isNull()) {
        painter->fillRect(option->rect, Qt::red);
    } else {
        QPixmap pixmap(icon);
        painter->drawPixmap(0, 0, icon);
   }
}

void RedWidget::mousePressEvent(QGraphicsSceneMouseEvent *event)
{
    emit clicked();
}

void RedWidget::setIconPath(const QString &path)
{
    icon = path;
    QPixmap pixmap(icon);
    setMinimumSize(pixmap.size().width() + 15, pixmap.size().height() + 15);
}
