/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KROSS_SCRIPTENGINE_H
#define KROSS_SCRIPTENGINE_H

#include <QString>
#include <QStringList>
#include <QVariantList>
#include <QHash>

namespace Kross {
    class Action;
}

class KrossScriptEngine
{
public:
    KrossScriptEngine() : m_action(0) {};
    ~KrossScriptEngine() {};

protected:
    bool initScript(QObject *parent, const QString &language,
                    const QString &name, const char* type,
                    QObject* object = 0, const QString& objName = QString());
    QVariant callFunction(const QString &name,
                          const QVariantList &args = QVariantList());

private:
    const QHash<QString, QStringList>& extensions() const;

    Kross::Action *m_action;
    static QHash<QString, QStringList> m_extensions;
};

#endif // KROSS_SCRIPTENGINE_H

