/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef SEARCH_CONTEXT_SCRIPT_H
#define SEARCH_CONTEXT_SCRIPT_H

#include <QObject>
#include <QString>
#include <QMetaType>

class SearchMatchScript;

namespace Plasma {
    class RunnerContext;
    class AbstractRunner;
}

class SearchContextScript : public QObject
{
    Q_OBJECT
public:
    SearchContextScript(Plasma::AbstractRunner* runner, Plasma::RunnerContext& searchContext);
    ~SearchContextScript();

public slots:
    QString query();
    bool addMatch(const QString &term, QObject *match);

private:
    Plasma::AbstractRunner* m_runner;
    Plasma::RunnerContext& m_searchContext;
};

#endif // SEARCH_CONTEXT_SCRIPT_H

