/*
  Copyright (c) 2010 Drake Justice <djustice.kde@gmail.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
*/

#ifndef MOVINGWALLPAPER_HEADER
#define MOVINGWALLPAPER_HEADER

#include <QtGui>

#include <KUrlRequester>

#include <Plasma/Wallpaper>

class MovingScene : public Plasma::Wallpaper
{
    Q_OBJECT
    public:
        MovingScene(QObject* parent, const QVariantList& args);
        ~MovingScene();

        virtual void paint(QPainter* painter, const QRectF& exposedRect);
        virtual void save(KConfigGroup &config);
        virtual QWidget* createConfigurationInterface(QWidget* parent);

    protected slots:
        void setWallpaper(const QString& url);
        void setWallpaper(const KUrl& url);
        void updateWallpaper();
	void changeMouseBehavior(int);

    signals:
        void settingsChanged(bool);

    protected:
        void init(const KConfigGroup &config);
        void mouseMoveEvent(QGraphicsSceneMouseEvent *event);
        void mousePressEvent(QGraphicsSceneMouseEvent *event);
        void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);

    private:
        bool m_moveWithMouse;
        int x;
        int y;
        int x_d;
        int y_d;
        KUrlRequester *m_kurl;
	QCheckBox *m_moveWithMouseCheckBox;
        QVBoxLayout *m_layout;
        QCursor *m_cursor;
        QString m_wallpaper;
        QImage m_image;
        QWidget *m_configWidget;
        QTimer *m_timer;
};

#endif
