/*
Copyright 2009 Beat Wolf <asraniel@fryx.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License or (at your option) version 3 or any later version
accepted by the membership of KDE e.V. (or its successor approved
by the membership of KDE e.V.), which shall act as a proxy
defined in Section 14 of version 3 of the license.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PATTERN_H
#define PATTERN_H

#include <Plasma/Wallpaper>
#include <QColor>
#include <QPixmap>

#include "ui_config.h"
#include "engine.h"

class KStandardDirs;

class ParticlesWallpaper : public Plasma::Wallpaper
{
Q_OBJECT
public:
    ParticlesWallpaper(QObject * parent, const QVariantList & args);
    ~ParticlesWallpaper();

    QWidget * createConfigurationInterface(QWidget * parent);
    void save(KConfigGroup & config);
    void paint(QPainter * painter, const QRectF & exposedRect);

    signals:
    void settingsChanged(bool);

protected:
    void init(const KConfigGroup & config);
private slots:
    void updateView();
    void widgetChanged();
private:
    void updatePixmap();
    void resetPixmap();
    
    Ui_ParticlesSettingsWidget m_ui;
    
    QColor m_bgColor;
    QColor m_pColor;
    QImage m_image;
    Engine engine;
    QSize m_size;
    int updateTime;
    int m_alpha;
    
    QPixmap m_pixmap;
};

K_EXPORT_PLASMA_WALLPAPER(particles, ParticlesWallpaper)

#endif //PLASMA_PLUGIN_WALLPAPER_PATTERN_H
