/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATBUTTONGROUP_H
#define KORATBUTTONGROUP_H

#include "koratbar_export.h"

#include "koratitem.h"
#include "koratbutton.h"

#include <QGraphicsItem>

namespace Korat
{
class ButtonGroupPrivate;
class KORATBAR_EXPORT ButtonGroup : public Item
{
    Q_OBJECT
public:
    ButtonGroup(QGraphicsItem *parent=0);
    virtual ~ButtonGroup();

    virtual bool isContainer();

    virtual QList<WeightList> availableWidths();
    virtual qreal getWidth(const WeightList &);
    virtual void adjustWidth(const WeightList &);

    void setLargestSizeMode(LayoutWeight mode);
    void setMinimumSizeMode(LayoutWeight mode);
    void setFixedSizeMode(LayoutWeight mode);

    void addButton(Button *button);
    void removeButton(int index);
    void removeButton(Button *button);
    Button *getButton(int index);

Q_SIGNALS:
    void sizeChanged();

private:
    friend class ButtonGroupPrivate;
    ButtonGroupPrivate *d;
    Q_PRIVATE_SLOT(d, void sizeUpdate())
};

}

#endif // KORATBUTTONGROUP_H
