/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KORATMAINWINDOW_H
#define KORATMAINWINDOW_H

#include "koratbar_export.h"
#include "koratmainwindowgraphics.h"

#include <QGraphicsWidget>
#include <QGraphicsItem>
#include <QWidget>
#include <QIcon>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QEvent>
#include <QString>

namespace Korat
{
class MainWindowPrivate;
class KORATBAR_EXPORT MainWindow : public QWidget
{
    Q_OBJECT
public:
    explicit MainWindow(QWidget *parent=0);
    virtual ~MainWindow();

    ToolBar *toolBar();
    void setToolBar(ToolBar *bar);

    QString title() const;
    void setTitle(const QString &title);

    QIcon icon() const;
    void setIcon(const QIcon &icon);

    virtual Drawer *drawer(Corner corner);
    virtual void addDrawer(Drawer *widget, Corner corner);

    virtual Dock *dock(Edge edge);
    virtual void setDock(Dock *widget, Edge edge);

    virtual QGraphicsWidget *centralWidget();
    virtual void setCentralWidget(QGraphicsWidget *widget);

protected:

    void paintEvent(QPaintEvent *e);
    void resizeEvent(QResizeEvent *e);
    bool event(QEvent *e);

private Q_SLOTS:
    void sizeUpdate();

private:
    MainWindowPrivate *d;
};
} // namespace Korat


#endif // KORATMAINWINDOW_H
