#ifndef WIDGET_H
#define WIDGET_H

#include <QGLWidget>
#include <QImage>
#include <QString>
#include <QPointF>

#include "composition.h"
#include "texture.h"
#include "mesh.h"

class QMouseEvent;

class Widget : public QGLWidget
{
    Q_OBJECT
public:
    Widget(const QString &imgFile);

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);

private:
    Quasar::Texture m_tex;
    QImage  m_image;
    QString m_location;
    QPointF m_point;
    Quasar::Composition m_compo;
    Quasar::Node       *m_node;
};

#endif
