#ifndef SCENE_H
#define SCENE_H

#include <QGraphicsScene>
#include <QPainter>
#include <QRectF>
#include <QPixmap>

class NodeItem;
class Edge;
namespace Quasar {
    class Composition;
}

class Scene : public QGraphicsScene
{
    Q_OBJECT
public:
    Scene(Quasar::Composition* compo, const QRectF &sceneRect, QObject *parent=0);

    NodeItem *nodeAt(const QPointF &pt) const;
protected:
    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent * mouseEvent);
    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent);

    void dragEnterEvent(QGraphicsSceneDragDropEvent* event);
    void dragMoveEvent(QGraphicsSceneDragDropEvent* event);
    void dropEvent(QGraphicsSceneDragDropEvent* event);

private:
    Edge *m_currentEdge;
    Quasar::Composition* m_composition;
};

#endif
