#ifndef PROPERTYEDITOR_H
#define PROPERTYEDITOR_H

#include <QWidget>

#include <QHash>
#include <QPointer>

namespace Quasar {
    class Node;
}
class QBoxLayout;

class PropertyEditor : public QWidget
{
    Q_OBJECT
public:
    PropertyEditor(QWidget *parent=0);

    void setNode(Quasar::Node *node);
    Quasar::Node *node() const;

signals:
    void edited();
private slots:
    void changed(const QString &name,
                 const QVariant &val);


private:
    struct Prop {
        Quasar::Node  *parent;
        const QString &name;
    };
    QHash<Prop*, QWidget*> m_editors;

    QPointer<Quasar::Node> m_node;
    QBoxLayout *m_layout;
};

#endif
