#ifndef QUASAR_COMPOSITION_H
#define QUASAR_COMPOSITION_H

#include <texture.h>
#include <QObject>
#include <QSize>

class QWidget;
class QGraphicsItem;
class QPainter;

namespace Quasar
{
    class Node;

    class Composition : public QObject
    {
        Q_OBJECT
    public:
        static QStringList groups();
        static QStringList nodesInGroup(const QString &group);
    public:
        Composition(QWidget *parent=0);
        Composition(QGraphicsItem *parent);
        ~Composition();

        QSize size() const;

        QString toXml() const;
        bool fromXml(const QString &xml);

        void addNode(Node *node, Node *parent=0);
        void removeNode(Node *node);
        Node *createNode(const QString &url);
    public slots:
        void prepare();
        void execute();
        Texture renderToTexture();

    private:
        class Private;
        Private *d;
    };
}

#endif
