#ifndef QUASAR_FILTERNODE_H
#define QUASAR_FILTERNODE_H

#include "shadernode.h"

#include "texture.h"
#include "shader_types.h"

namespace Quasar
{
    class FilterNodePrivate;

    class FilterNode : public ShaderNode
    {
        Q_OBJECT
        Q_DECLARE_PRIVATE(FilterNode)
    public:
        FilterNode(const QString &name);

        void setShaderSources(const QString &vs, const QString &fs);
        virtual bool isFilterNode() const;

        virtual void prepare();

    protected:
        virtual bool execute();
        virtual void aboutToExecute();
        void updateFilterSize(const Texture &master, int meshSize);

        void propertyChanged(const QString &name, const QVariant &val);
        virtual void unkownPropertyChanged(const QString &name, const QVariant &val);
    };
}

#endif
