#ifndef QUASAR_NODE_P_H
#define QUASAR_NODE_P_H

#include "node.h"

namespace Quasar
{
    class NodePrivate
    {
        Q_DECLARE_PUBLIC(Node)
    public:
        NodePrivate()
        {
            dirty = true;
        }
        virtual ~NodePrivate()
        {}
        bool removeFromReceivers(const QString &outKey,
                                 Node *receiver,
                                 const QString &inKey);
        void removeSender(Node *n, const QString &outKey);


        bool removeFromSenders(const QString &outKey);
        void removeReceiver(const QString &outKey,
                            Node *n, const QString &inKey);

        Node                         *q_ptr;
        bool                          dirty;
        QString                       name;
        QHash<QString, Property>      properties;

        QMultiHash<QString, Node::Connection>    receivers;
        QHash<QString, Node::Connection> senders;


        bool setPropertyPrivate(Property &prop,
                                const QVariant &value);
    };
}

#endif
