/*
    This file is part of the KDE project.
    Copyright (c) 2006 Friedrich W. H. Kossebau <Friedrich.W.H@Kossebau.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License version 2 as published by the Free Software Foundation.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301  USA
*/


// qt specific
#include <qtooltip.h>
#include <qimage.h>
// applet specific
#include "lazyfillmenu.h"
#include "menubutton.h"
#include "kuserface.h"
#include "ksessionmenufiller.h"
#include "ksessionmenubuttonfiller.h"

KSessionMenuButtonFiller::KSessionMenuButtonFiller( const KUser U, KLocalSessionManager *SM )
: User( U ),
  SessionManager( SM )
{
}

void KSessionMenuButtonFiller::fill( MenuButton *Button )
{
  int Style = ShowFaceBefore | FirstFullName | TwoRows;

  QToolTip::add( Button, KUserRichTexter::self()->createUserDesc(User,Style) );

  Button->setMenu( new LazyFillMenu(new KSessionMenuFiller(User,SessionManager),true,Button) );
  Button->setDrawArrow( false );

  fillIcon( Button );
}


void KSessionMenuButtonFiller::fillIcon( MenuButton *Button )
{
  int PixmapSize = Button->pixmapSize();
  Button->setIcon( KUserFaceLoader::self()->loadFaceIcon(User,KIcon::NoGroup,PixmapSize) );
}


KSessionMenuButtonFiller::~KSessionMenuButtonFiller()
{}
